/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/



char * debug_r5900_reg [34] = {
"r0", "at", "v0", "v1", "a0", "a1", "a2", "a3",
"t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7",
"s0", "s1", "s2", "s3", "s4", "s5", "s6", "s7",
"t8", "t9",
"k0", "k1",
"gp", "sp",
"s8",
"ra",
"hi", "lo"
};	

char * debug_r5900_cop1_reg [32] = {
"fp0",	"fp1",	"fp2",	"fp3",	"fp4",	"fp5",	"fp6",	"fp7",
"fp8",	"fp9",	"fp10",	"fp11",	"fp12",	"fp13",	"fp14",	"fp15", 
"fp16",	"fp17",	"fp18",	"fp19",	"fp20",	"fp21",	"fp22",	"fp23",
"fp24", "fp25",	"fp26",	"fp27",	"fp28",	"fp29",	"fp30",	"fp31"
};	

char * debug_r5900_cop0_reg [32] = {
	"Index",			"Random",	"EntryLo0",	"EntryLo1",	"Context",		"PageMask",		"Wired",	" ", 	
	"BadWAddr",			"Count",	"EntryHi",	"Compare",	"Status",		"Cause",		"EPC",		"PRiD",
	"Config/Config1",	" ",		"WatchLo",	"WatchHi",	"XContext",		" ", 			" ", 		"Debug",				
	"DEPC",				"PerfCnt",	"ErrCtl",	"CacheErr", "TagLo/DataLo",	"TagHi/DataHi",	"ErrorEPC",	"DESAVE"
};




static void (*normal_opc[64])(void) =
{
   SPECIAL,	REGIMM,		J,		JAL,	BEQ,		BNE,	BLEZ,	BGTZ,
   ADDI, 	ADDIU, 		SLTI,	SLTIU,	ANDI,		ORI,	XORI,	LUI,
   COP0, 	COP1, 		COP2,	COP1X,	BEQL,		BNEL,	BLEZL,	BGTZL,
   DADDI, 	DADDIU, 	LDL,	LDR,	SPECIAL2,	JALX,	LQ,		SQ,
   LB, 		LH, 		LWL,	LW,		LBU,		LHU,	LWR,	LWU,
   SB, 		SH, 		SWL,	SW,		SDL,		SDR,	SWR,	CACHE,
   LL, 		LWC1, 		LWC2,	PREF,	LLD,		LDC1,	LDC2,	LD,
   SC, 		SWC1, 		SWC2,	NI,		SCD, 		SDC1,	SDC2,	SD
};

char * debug_normal_opc[64] =
{
   "SPECIAL",	"REGIMM",	"J",	"JAL",		"BEQ",		"BNE",	"BLEZ",		"BGTZ",
   "ADDI",		"ADDIU",	"SLTI",	"SLTIU",	"ANDI",		"ORI",	"XORI", 	"LUI",
   "COP0",		"COP1",		"COP2",	"COP1X",	"BEQL",		"BNEL",	"BLEZL", 	"BGTZL",
   "DADDI",		"DADDIU",	"LDL",	"LDR",		"SPECIAL2",	"JALX",	"LQ", 		"SQ",
   "LB",		"LH",		"LWL",	"LW",		"LBU",		"LHU",	"LWR",		"LWU",
   "SB",		"SH",		"SWL",	"SW",		"SDL",		"SDR",	"SWR",		"CACHE",
   "LL",		"LWC1",		"LWC2",	"PREF",		"LLD",		"LDC1",	"LDC2",		"LD",
   "SC",		"SWC1",		"SWC2",	"NI",		"SCD",		"SDC1",	"SDC2",		"SD"
};



static void (*special_opc[64])(void) =
{
   SLL,		MOVCI,	SRL,	SRA,	SLLV,		NI,		SLRV,	SRAV,
   JR,		JALR,	MOVZ,	MOVN,	SYSCALL,	BREAK,	NI,		SYNC,
   MFHI,	MTHI,	MFLO,	MTLO,	DSLLV,		NI,		DSRLV,	DSRAV,
   MULT,	MULTU,	DIV,	DIVU,	DMULT,		DMULTU,	DDIV,	DDIVU,
   ADD,		ADDU,	SUB,	SUBU,	AND,		OR,		XOR,	NOR,
   NI,		NI,		SLT,	SLTU,	DADD,		DADDU,	DSUB,	DSUBU,
   TGE,		TGEU,	TLT,	TLTU,	TEQ,		NI,		TNE,	NI,
   DSLL,	NI,		DSRL,	DSRA,	DSLL32,		NI,		DSRL32,	DSRA32
};

char * debug_special_opc[64] =
{
   "SLL",	"MOVCI",	"SRL",	"SRA",	"SLLV",		"NI",		"SLRV",		"SRAV",
   "JR",	"JALR ",	"MOVZ",	"MOVN",	"SYSCALL",	"BREAK",	"NI",		"SYNC",
   "MFHI",	"MTHI",		"MFLO",	"MTLO",	"DSLLV",	"NI",		"DSRLV",	"DSRAV",
   "MULT",	"MULTU", 	"DIV",	"DIVU",	"DMULT",	"DMULTU",	"DDIV",		"DDIVU",
   "ADD",	"ADDU", 	"SUB",	"SUBU",	"AND",		"OR",		"XOR",		"NOR",
   "NI",	"NI", 		"SLT",	"SLTU",	"DADD",		"DADDU",	"DSUB",		"DSUBU",
   "TGE",	"TGEU", 	"TLT",	"TLTU",	"TEQ",		"NI",		"TNE",		"NI",
   "DSLL",	"NI", 		"DSRL",	"DSRA",	"DSLL32",	"NI",		"DSRL32",	"DSRA32"
};



static void (*regimm_opc[32])(void) =
{
   BLTZ,	BGEZ,	BLTZL,		BGEZL,		NI,		NI,	NI,		NI,
   TGEI,	TGEIU, 	TLTI,		TLTIU,		TEQI,	NI,	TNEI,	NI,
   BLTZAL,	BGEZAL, BLTZALL,	BGEZALL,	NI,		NI,	NI,		NI,
   NI,		NI,		NI,			NI,			NI,		NI, NI,		NI 
};


char * debug_regimm_opc[32] =
{
   "BLTZ",		"BGEZ",		"BLTZL",	"BGEZL",	"NI",	"NI",	"NI",	"NI",
   "TGEI",		"TGEIU", 	"TLTI",		"TLTIU",	"TEQI", "NI",	"TNEI",	"NI",
   "BLTZAL",	"BGEZAL",	"BLTZALL",	"BGEZALL",	"NI",	"NI",	"NI",	"NI",
   "NI",		"NI",		"NI",		"NI",		"NI",	"NI",	"NI",	"NI" 
};

static void (*cop0_opc[32])(void) =
{
	MFC0,	DMFC0,	NI,	NI,	MTC0,	DMTC0,	NI,	NI,
   	NI, 	NI, 	NI,	NI,	NI,		NI,		NI, NI,
  	C0,		C0,		C0,	C0,	C0,		C0,		C0,	C0,
	C0,		C0,		C0,	C0,	C0,		C0,		C0,	C0
};

char * debug_cop0_opc[32] =
{
   	"MFC0", "DMFC0",	"NI",	"NI",	"MTC0",	"DMTC0", 	"NI",	"NI",
   	"NI", 	"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI", 	"NI",
  	"C0",	"C0",		"C0",	"C0",	"C0",	"C0",		"C0",	"C0",
   	"C0",	"C0",		"C0",	"C0",	"C0",	"C0",		"C0",	"C0"
};

static void (*cop0c0_opc[64])(void) =
{
	NI, 	TLBR, 	TLBWI, 	NI, 	NI,		NI,		TLBWR,		NI,
	TLBP,	NI,		NI,		NI,		NI,		NI,		NI,			NI,		
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
	ERET, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		DERET ,	 
 	WAIT, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
	EI, 	DI, 	NI, 	NI,		NI, 	NI, 	NI, 		NI  	 
};


char * debug_cop0c0_opc[64] =
{
	"NI", 	"TLBR", "TLBWI", 	"NI", 	"NI",	"NI",	"TLBWR",	"NI",
	"TLBP",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",		
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"ERET",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"DERET",
	"WAIT",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"EI",	"DI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI" 	 
};

static void (*syscall_fct[256])(void) =
{
//0
SYSCALL_RFU000_FullReset, 		SYSCALL_ResetEE, 				SYSCALL_SetGsCrt, 			SYSCALL_RFU003,
SYSCALL_Exit,					SYSCALL_RFU005, 				SYSCALL_LoadPS2Exe, 		SYSCALL_ExecPS2, 
//8
SYSCALL_RFU008, 				SYSCALL_RFU009, 				SYSCALL_AddSbusIntcHandler,	SYSCALL_RemoveSbusIntcHandler, 	
SYSCALL_Interrupt2Iop, 			SYSCALL_SetVTLBRefillHandler, 	SYSCALL_SetVCommonHandler, 	SYSCALL_SetVInterruptHandler, 
//16
SYSCALL_AddIntcHandler, 		SYSCALL_RemoveIntcHandler, 		SYSCALL_AddDmacHandler, 	SYSCALL_RemoveDmacHandler,
SYSCALL__EnableIntc, 			SYSCALL__DisableIntc, 			SYSCALL__EnableDmac, 		SYSCALL__DisableDmac, 
//24
SYSCALL__SetAlarm, 				SYSCALL__ReleaseAlarm, 			SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
//32
SYSCALL_CreateThread,			SYSCALL_DeleteThread, 			SYSCALL_StartThread, 		SYSCALL_ExitThread,
SYSCALL_ExitDeleteThread, 		SYSCALL_TerminateThread, 		SYSCALL_NI, 				SYSCALL_DisableDispatchThread,
//40
SYSCALL_EnableDispatchThread,	SYSCALL_ChangeThreadPriority,	SYSCALL_NI, 				SYSCALL_RotateThreadReadyQueue,
SYSCALL_NI, 					SYSCALL_ReleaseWaitThread, 		SYSCALL_NI, 				SYSCALL_GetThreadId, 
//48
SYSCALL_ReferThreadStatus, 		SYSCALL_NI, 					SYSCALL_SleepThread, 		SYSCALL_WakeupThread,
SYSCALL_NI, 					SYSCALL_CancelWakeupThread, 	SYSCALL_NI, 				SYSCALL_SuspendThread, 
//56
SYSCALL_NI, 					SYSCALL_ResumeThread, 			SYSCALL_NI, 				SYSCALL_JoinThread,
SYSCALL_RFU060, 				SYSCALL_RFU061, 				SYSCALL_EndOfHeap, 			SYSCALL_RFU063, 
//64
SYSCALL_CreateSema, 			SYSCALL_DeleteSema, 			SYSCALL_SignalSema, 		SYSCALL_NI,
SYSCALL_WaitSema, 				SYSCALL_PollSema, 				SYSCALL_NI, 				SYSCALL_ReferSemaStatus, 
//72
SYSCALL_NI, 					SYSCALL_RFU073, 				SYSCALL_SetOsdConfigParam, 	SYSCALL_GetOsdConfigParam,
SYSCALL_GetGsHParam, 			SYSCALL_GetGsVParam, 			SYSCALL_SetGsHParam, 		SYSCALL_SetGsVParam, 
//80
SYSCALL_RFU080_CreateEventFlag,	SYSCALL_RFU081_DeleteEventFlag,	SYSCALL_RFU082_SetEventFlag,SYSCALL_RFU083_iSetEventFlag,
SYSCALL_RFU084_ClearEventFlag, 	SYSCALL_RFU085_iClearEventFlag, SYSCALL_RFU086_WaitEvnetFlag,SYSCALL_RFU087_PollEvnetFlag, 
//88
SYSCALL_RFU088_iPollEvnetFlag, 	SYSCALL_RFU089_ReferEventFlagStatus,SYSCALL_NI,				SYSCALL_RFU091,
SYSCALL_EnableIntcHandler, 		SYSCALL_DisableIntcHandler, 	SYSCALL_EnableDmacHandler, 	SYSCALL_DisableDmacHandler, 
//96
SYSCALL_KSeg0, 					SYSCALL_EnableCache, 			SYSCALL_DisableCache, 		SYSCALL_GetCop0,
SYSCALL_FlushCache, 			SYSCALL_NI, 					SYSCALL_CpuConfig, 			SYSCALL_NI, 
//104
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_sceSifStopDma, 
SYSCALL_SetCPUTimerHandler, 	SYSCALL_SetCPUTimer, 			SYSCALL_ForceRead, 			SYSCALL_ForceWrite, 
//112
SYSCALL_GsGetIMR, 				SYSCALL_GsPutIMR, 				SYSCALL_SetPgifHandler, 	SYSCALL_SetVSyncFlag,
SYSCALL_RFU116, 				SYSCALL_print, 					SYSCALL_sceSifDmaStat, 		SYSCALL_sceSifSetDma, 
//120
SYSCALL_sceSifSetDChain, 		SYSCALL_sceSifSetReg, 			SYSCALL_sceSifGetReg, 		SYSCALL_ExecOSD, 
SYSCALL_Deci2Call, 				SYSCALL_PSMode, 				SYSCALL_MachineType, 		SYSCALL_GetMemorySize, 
//128
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
//136
SYSCALL_isceSifSetDChain, 		SYSCALL_isceSifSetDma, 			SYSCALL_isceSifDmaStat, 	SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_iGsPutIMR, 
//144
SYSCALL_iGsGetIMR, 				SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI,			 			SYSCALL_iCpuConfig, 		SYSCALL_NI, 
//152
SYSCALL_iFlushCache,	 		SYSCALL_iGetCop0, 				SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_UKN_1, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//160
SYSCALL_NI, 					SYSCALL_iDisableDmacHandler,	SYSCALL_iEnableDmacHandler,	SYSCALL_iDisableIntcHandler,
SYSCALL_iEnableIntcHandler, 	SYSCALL_NI, 					SYSCALL_RFU090_iReferEventFlagStatus, SYSCALL_NI,
//168
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI,					SYSCALL_NI,
//176
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//184
SYSCALL_iReferSemaStatus, 		SYSCALL_NI, 					SYSCALL_iPollSema, 			SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_iSignalSema, 			SYSCALL_NI, 				SYSCALL_NI,
//192
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_iResumeThread, 		SYSCALL_NI,
//200
SYSCALL_iSuspendThread, 		SYSCALL_NI, 					SYSCALL_iCancelWakeupThread,SYSCALL_NI,
SYSCALL_iWakeupThread, 			SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_iReferThreadStatus,
//208
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_iReleaseWaitThread, SYSCALL_NI,
SYSCALL_iRotateThreadReadyQueue,SYSCALL_NI, 					SYSCALL_iChangeThreadPriority,SYSCALL_NI,
//216
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_iTerminateThread, 	SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 		
//224
SYSCALL_NI, 					SYSCALL__iReleaseAlarm, 		SYSCALL__iSetAlarm, 		SYSCALL__iDisableDmac,
SYSCALL__iEnableDmac, 			SYSCALL__iDisableIntc, 			SYSCALL__iEnableIntc, 		SYSCALL_NI,
//232
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//240
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//248
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI 

	          
};


char * debug_syscall[256] =
{
"SYSCALL_RFU000_FullReset", 	"SYSCALL_ResetEE", 				"SYSCALL_SetGsCrt", 			"SYSCALL_RFU003",
"SYSCALL_Exit", 				"SYSCALL_RFU005", 				"SYSCALL_LoadPS2Exe", 			"SYSCALL_ExecPS2", 
"SYSCALL_RFU008", 				"SYSCALL_RFU009", 				"SYSCALL_AddSbusIntcHandler", 	"SYSCALL_RemoveSbusIntcHandler",
"SYSCALL_Interrupt2Iop",		"SYSCALL_SetVTLBRefillHandler", "SYSCALL_SetVCommonHandler", 	"SYSCALL_SetVInterruptHandler", 
"SYSCALL_AddIntcHandler", 		"SYSCALL_RemoveIntcHandler", 	"SYSCALL_AddDmacHandler", 		"SYSCALL_RemoveDmacHandler",
"SYSCALL__EnableIntc", 			"SYSCALL__DisableIntc", 		"SYSCALL__EnableDmac", 			"SYSCALL__DisableDmac", 
"SYSCALL__SetAlarm", 			"SYSCALL__ReleaseAlarm", 		"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 
"SYSCALL_CreateThread",			"SYSCALL_DeleteThread", 		"SYSCALL_StartThread", 			"SYSCALL_ExitThread",
"SYSCALL_ExitDeleteThread", 	"SYSCALL_TerminateThread", 		"SYSCALL_NI", 					"SYSCALL_DisableDispatchThread", 	
"SYSCALL_EnableDispatchThread", "SYSCALL_ChangeThreadPriority",	"SYSCALL_NI", 					"SYSCALL_RotateThreadReadyQueue", 
"SYSCALL_NI", 					"SYSCALL_ReleaseWaitThread", 	"SYSCALL_NI", 					"SYSCALL_GetThreadId", 
"SYSCALL_ReferThreadStatus", 	"SYSCALL_NI", 					"SYSCALL_SleepThread", 			"SYSCALL_WakeupThread",
"SYSCALL_NI", 					"SYSCALL_CancelWakeupThread", 	"SYSCALL_NI", 					"SYSCALL_SuspendThread", 
"SYSCALL_NI", 					"SYSCALL_ResumeThread", 		"SYSCALL_NI", 					"SYSCALL_JoinThread",
"SYSCALL_RFU060", 				"SYSCALL_RFU061", 				"SYSCALL_EndOfHeap", 			"SYSCALL_RFU063", 
"SYSCALL_CreateSema", 			"SYSCALL_DeleteSema", 			"SYSCALL_SignalSema", 			"SYSCALL_NI",
"SYSCALL_WaitSema", 			"SYSCALL_PollSema", 			"SYSCALL_NI", 					"SYSCALL_ReferSemaStatus", 
"SYSCALL_NI", 					"SYSCALL_RFU073", 				"SYSCALL_SetOsdConfigParam", 	"SYSCALL_GetOsdConfigParam", 	
"SYSCALL_GetGsHParam", 			"SYSCALL_GetGsVParam", 			"SYSCALL_SetGsHParam", 			"SYSCALL_SetGsVParam", 
"SYSCALL_RFU080_CreateEventFlag","SYSCALL_RFU081_DeleteEventFlag","SYSCALL_RFU082_SetEventFlag","SYSCALL_RFU083_iSetEventFlag", 
"SYSCALL_RFU084_ClearEventFlag","SYSCALL_RFU085_iClearEventFlag","SYSCALL_RFU086_WaitEvnetFlag","SYSCALL_RFU087_PollEvnetFlag", 
"SYSCALL_RFU088_iPollEvnetFlag","SYSCALL_RFU089_ReferEventFlagStatus", "SYSCALL_NI", 			"SYSCALL_RFU091",
"SYSCALL_EnableIntcHandler", 	"SYSCALL_DisableIntcHandler", 	"SYSCALL_EnableDmacHandler", 	"SYSCALL_DisableDmacHandler", 
"SYSCALL_KSeg0", 				"SYSCALL_EnableCache", 			"SYSCALL_DisableCache", 		"SYSCALL_GetCop0",
"SYSCALL_FlushCache", 			"SYSCALL_NI", 					"SYSCALL_CpuConfig", 			"SYSCALL_NI", 
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_sceSifStopDma",
"SYSCALL_SetCPUTimerHandler", 	"SYSCALL_SetCPUTimer", 			"SYSCALL_ForceRead", 			"SYSCALL_ForceWrite",
"SYSCALL_GsGetIMR", 			"SYSCALL_GsPutIMR", 			"SYSCALL_SetPgifHandler", 		"SYSCALL_SetVSyncFlag",
"SYSCALL_RFU116", 				"SYSCALL_print", 				"SYSCALL_sceSifDmaStat", 		"SYSCALL_sceSifSetDma", 
"SYSCALL_sceSifSetDChain", 		"SYSCALL_sceSifSetReg", 		"SYSCALL_sceSifGetReg", 		"SYSCALL_ExecOSD",
"SYSCALL_Deci2Call", 			"SYSCALL_PSMode", 				"SYSCALL_MachineType", 			"SYSCALL_GetMemorySize", 
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 
"SYSCALL_isceSifSetDChain", 	"SYSCALL_isceSifSetDma", 		"SYSCALL_isceSifDmaStat", 		"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iGsPutIMR", 
"SYSCALL_iGsGetIMR", 			"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iCpuConfig", 			"SYSCALL_NI", 
"SYSCALL_iFlushCache", 			"SYSCALL_iGetCop0", 			"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_UKN_1", 				"SYSCALL_NI",					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_iDisableDmacHandler", 	"SYSCALL_iEnableDmacHandler", 	"SYSCALL_iDisableIntcHandler",
"SYSCALL_iEnableIntcHandler", 	"SYSCALL_NI", 					"SYSCALL_RFU090_iReferEventFlagStatus", "SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_iReferSemaStatus", 	"SYSCALL_NI", 					"SYSCALL_iPollSema", 			"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_iSignalSema", 			"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iResumeThread", 		"SYSCALL_NI",
"SYSCALL_iSuspendThread", 		"SYSCALL_NI", 					"SYSCALL_iCancelWakeupThread", 	"SYSCALL_NI",
"SYSCALL_iWakeupThread", 		"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iReferThreadStatus",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iReleaseWaitThread", 	"SYSCALL_NI",
"SYSCALL_iRotateThreadReadyQueue","SYSCALL_NI", 				"SYSCALL_iChangeThreadPriority", "SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iTerminateThread", 	"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 		
"SYSCALL_NI", 					"SYSCALL__iReleaseAlarm", 		"SYSCALL__iSetAlarm", 			"SYSCALL__iDisableDmac",
"SYSCALL__iEnableDmac", 		"SYSCALL__iDisableIntc", 		"SYSCALL__iEnableIntc", 		"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI" 


};



static void (*special2_opc[64])(void) =
{
	MADD,	MADDU,	MUL,	NI,		MSUB,	MSUBU,	NI,		NI,	
	NI,		NI,		NI,		NI,		NI,		NI,		NI,		NI,	
	NI,		NI,		NI,		NI,		NI,		NI,		NI,		NI,	
	MULT1,	NI,		NI,		NI,		NI,		NI,		NI,		NI,	
	CLZ,	CLO,	NI,		NI,		DLCZ,	DLCO,	NI,		NI,	
	NI,		NI,		NI,		NI,		NI,		NI,		NI,		NI,	
	NI,		NI,		NI,		NI,		NI,		NI,		NI,		NI,	
	NI,		NI,		NI,		NI,		NI,		NI,		NI,		SDBBP							
};

char * debug_special2_opc[64] =
{
	"MADD",		"MADDU",	"MUL",	"NI",	"MSUB",		"MSUBU",	"NI",	"NI",	
	"NI",		"NI",		"NI",	"NI",	"NI",		"NI",		"NI",	"NI",	
	"NI",		"NI",		"NI",	"NI",	"NI",		"NI",		"NI",	"NI",	
	"MULT1",	"NI",		"NI",	"NI",	"NI",		"NI",		"NI",	"NI",	
	"CLZ",		"CLO",		"NI",	"NI",	"DLCZ",		"DLCO",		"NI",	"NI",	
	"NI",		"NI",		"NI",	"NI",	"NI",		"NI",		"NI",	"NI",	
	"NI",		"NI",		"NI",	"NI",	"NI",		"NI",		"NI",	"NI",	
	"NI",		"NI",		"NI",	"NI",	"NI",		"NI",		"NI",	"SDBBP"							
};

static void (*cop1_opc[32])(void) =
{
	MFC1,	DMFC1,	CFC1,	NI,		MTC1,	DMTC1,	CTC1,	NI,
	BC1, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI,
	COP1_S,	COP1_D, NI, 	NI, 	COP1_W,	COP1_L,	NI, 	NI,
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI							
};

char * debug_cop1_opc[32] =
{
	"MFC1",		"DMFC1",	"CFC1",	"NI",		"MTC1",		"DMTC1",	"CTC1",	"NI",
	"BC1", 		"NI", 		"NI", 	"NI", 		"NI", 		"NI", 		"NI", 	"NI",
	"COP1_S",	"COP1_D", 	"NI", 	"NI", 		"COP1_W",	"COP1_L",	"NI", 	"NI",
	"NI", 		"NI", 		"NI", 	"NI", 		"NI", 		"NI", 		"NI", 	"NI"							
};


static void (*cop1_bc1_opc[4])(void) =
{
	BC1F, BC1T,
	BC1FL,BC1TL
};

char * debug_cop1_bc1_opc[4] =
{
	"BC1F", "BC1T",
	"BC1FL","BC1TL"
};

static void (*cop1_s_opc[64])(void) =
{
	ADD_S, 		SUB_S, 		MUL_S, 		DIV_S, 		SQRT_S, 	ABS_S, 		MOV_S, 		NEG_S,
	ROUND_L_S,	TRUNC_L_S,	CEIL_L_S,	FLOOR_L_S,	ROUND_W_S,	TRUNC_W_S,	CEIL_W_S,	FLOOR_W_S,
	NI,			MOVCF_S,	MOVZ_S,		MOVN_S,		NI,			RECIP_S,  	RSQRT_S,  	NI,
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI,			CVT_D_S, 	NI, 		NI,			CVT_W_S,	CVT_L_S,	NI,			NI,
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	C_F_S, 		C_UN_S,		C_EQ_S,		C_UEQ_S,	C_OLT_S,	C_ULT_S,	C_OLE_S,	C_ULE_S,
	C_SF_S,		C_NGLE_S, 	C_SEQ_S,	C_NGL_S,	C_LT_S,		C_NGE_S,	C_LE_S,		C_NGT_S
};

char * debug_cop1_s_opc[64] =
{
	"ADD_S", 	"SUB_S", 	"MUL_S", 	"DIV_S", 	"SQRT_S", 	"ABS_S", 	"MOV_S", 	"NEG_S",
	"ROUND_L_S","TRUNC_L_S","CEIL_L_S",	"FLOOR_L_S","ROUND_W_S","TRUNC_W_S","CEIL_W_S",	"FLOOR_W_S",
	"NI",		"MOVCF_S",	"MOVZ_S",	"MOVN_S",	"NI",		"RECIP_S",  "RSQRT_S", 	"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",		
	"NI",		"CVT_D_S", 	"NI", 		"NI",		"CVT_W_S",	"CVT_L_S",	"NI",		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",		
	"C_F_S", 	"C_UN_S",	"C_EQ_S",	"C_UEQ_S",	"C_OLT_S",	"C_ULT_S",	"C_OLE_S",	"C_ULE_S",
	"C_SF_S",	"C_NGLE_S", "C_SEQ_S",	"C_NGL_S",	"C_LT_S",	"C_NGE_S",	"C_LE_S",	"C_NGT_S"
};


static void (*cop1_d_opc[64])(void) =
{
	ADD_D,		SUB_D,		MUL_D,		DIV_D,		SQRT_D,		ABS_D,		MOV_D,		NEG_D,
	ROUND_L_D,	TRUNC_L_D,	CEIL_L_D,	FLOOR_L_D,	ROUND_W_D,	TRUNC_W_D,	CEIL_W_D,	FLOOR_W_D,
	NI,			MOVCF_D,	MOVZ_D,		MOVN_D,		NI,			RECIP_D,	RSQRT_D,	NI,
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	CVT_S_D,	NI,			NI,			NI,			CVT_W_D,	CVT_L_D,	NI,			NI,
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	C_F_D,		C_UN_D,		C_EQ_D,		C_UEQ_D,	C_OLT_D,	C_ULT_D,	C_OLE_D,	C_ULE_D,
	C_SF_D,		C_NGLE_D,	C_SEQ_D,	C_NGL_D,	C_LT_D,		C_NGE_D,	C_LE_D,		C_NGT_D
};

char * debug_cop1_d_opc[64] =
{
	"ADD_D",	"SUB_D",	"MUL_D",	"DIV_D",	"SQRT_D",	"ABS_D",	"MOV_D",	"NEG_D",
	"ROUND_L_D","TRUNC_L_D","CEIL_L_D",	"FLOOR_L_D","ROUND_W_D","TRUNC_W_D","CEIL_W_D",	"FLOOR_W_D",
	"NI",		"MOVCF_D",	"MOVZ_D",	"MOVN_D",	"NI",		"RECIP_D",	"RSQRT_D",	"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"CVT_S_D",	"NI",		"NI",		"NI",		"CVT_W_D",	"CVT_L_D",	"NI"		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",		
	"C_F_D",	"C_UN_D",	"C_EQ_D",	"C_UEQ_D",	"C_OLT_D",	"C_ULT_D",	"C_OLE_D",	"C_ULE_D",
	"C_SF_D",	"C_NGLE_D",	"C_SEQ_D",	"C_NGL_D",	"C_LT_D",	"C_NGE_D",	"C_LE_D",	"C_NGT_D"
};


static void (*cop1_W_L_opc[64])(void) =
{
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	CVT_S,		CVT_D,		NI, 	NI, 		NI, 		NI, 		NI, 	NI, 			
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI		
};

char * debug_cop1_W_L_opc[64] =
{
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"CVT_S",	"CVT_D",	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI"	
	
};
	
static void (*cop1_movcf_opc[2])(void) =	
{
	MOVF_fmt, MOVT_fmt	
};	

char * debug_cop1_movcf_opc[2] =
{
	"MOVF_fmt", "MOVT_fmt"	
};

